Subject: bug#67687: Feature request: automatic tags management

From: Eli Zaretskii <[email-masked]>
Date: Sun, 31 Dec 2023 21:27:03 +0200

> Date: Sun, 31 Dec 2023 19:53:27 +0200
> Cc: [email-masked], [email-masked], [email-masked],
>  [email-masked]
> From: Dmitry Gutov <[email-masked]>
> 
> >> And either way it seems like a prerequisite for enabling
> >> etags-regen-mode by default sometimes in the future.
> > 
> > How so?  The fact that I loaded TAGS doesn't necessarily mean I don't
> > want it updated when the sources change.  Or what am I missing?
> 
> a) We won't add new files to the index, because we (apparently) can't 
> simply use the project's list of files -- there is no guarantee that it 
> matches the fileset that the original author of the TAGS file had in mind.

The user has etags-regen-ignores to control that.

> b) There is no way to pick up the --regex options used for generating 
> the original TAGS, or any other options we don't know about.

There are defcustoms to control both of those.

> Either way, we get a poorly-defined behavior with edge cases that are 
> likely to surprise the user at different points of time. So we might 
> indeed grow such a capability, but it'll probably stay off by default.

I agree that sometimes it could be against the user's expectations.
But I also think that other times it is according to user's
expectations.  Which tells me that this is a separate issue that needs
a separate knob; we shouldn't deterministically deduce what users want
in this respect from the fact that he/she loaded an existing tags
table.  Moreover, it is quite possible that even when the mode is
turned on, users might want sometimes to load tags tables manually.